+} # Get YYYYmmddTHHMMSS±zzzz
+dateShort(){
+ # Desc: Date without separators (YYYYmmdd)
+ # Usage: dateShort
+ # Output: stdout: date (ISO-8601, no separators)
+ local TIME_CURRENT DATE_CURRENT_SHORT
+ TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
+ DATE_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%d)"; # Produce separator-less current date with resolution 1 day.
+ echo "$DATE_CURRENT_SHORT";
+} # Get YYYYmmdd
+timeDuration(){
+ # Desc: Output approximate time duration string before given time (default:current date)
+ # Ref/Attrib: ISO-8601:2004(E), §4.4.4.2 Representations of time intervals by duration and context information
+ # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), §2.2.1.2)
+ # Usage: timeDuration [arg1] ([arg2])
+ # Version: 1.0.1
+ # Input: arg1: seconds as base 10 integer >= 0 (ex: 3601)
+ # arg2: precision level (optional; default=2)
+ # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
+ # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
+ # Depends: date 8 (gnucoreutils), yell,
+ local returnState ARG1 ARG2 remainder precision witherPrecision
+ local fullYears fullMonths fullDays fullHours fullMinutes fullSeconds
+ local displayYears displayMonths displayDays displayHours displayMinutes displaySeconds
+ local hasYears hasMonths hasDays hasHours hasMinutes hasSeconds
+
+ ARG1="$1";
+ ARG2="$2";
+ precision=2; # set default precision
+ returnState="true"; # set default return state
+
+ # Check that between one and two arguments is supplied
+ if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
+ yell "ERROR:Invalid number of arguments:$# . Exiting.";
+ returnState="ERROR_INPUT"; fi
+
+ # Check that arg1 provided
+ if [[ $# -ge 1 ]]; then
+ ## Check that arg1 is a positive integer
+ if [[ "$ARG1" =~ ^[[:digit:]]+$ ]]; then
+ :
+ else
+ yell "ERROR:ARG1 not a digit.";
+ returnState="ERROR_INPUT";
+ fi
+ else
+ yell "ERROR:No argument provided. Exiting.";
+ exit 1;
+ fi
+
+ # Consider whether arg2 was provided
+ if [[ $# -eq 2 ]]; then
+ # Check that the second arg is a positive integer
+ if [[ "$ARG2" =~ ^[[:digit:]]+$ ]] && [[ "$ARG2" -gt 0 ]]; then
+ precision="$ARG2";
+ else
+ yell "ERROR:ARG2 not a positive integer. (is $ARG2 ). Leaving early.";
+ returnState="ERROR_INPUT";
+ fi;
+ else
+ :
+ fi;
+
+ remainder="$ARG1" ; # seconds
+ ## Calculate full years Y, update remainder
+ fullYears=$(( remainder / (365*24*60*60) ));
+ remainder=$(( remainder - (fullYears*365*24*60*60) ));
+ ## Calculate full months M, update remainder
+ fullMonths=$(( remainder / (30*24*60*60) ));
+ remainder=$(( remainder - (fullMonths*30*24*60*60) ));
+ ## Calculate full days D, update remainder
+ fullDays=$(( remainder / (24*60*60) ));
+ remainder=$(( remainder - (fullDays*24*60*60) ));
+ ## Calculate full hours H, update remainder
+ fullHours=$(( remainder / (60*60) ));
+ remainder=$(( remainder - (fullHours*60*60) ));
+ ## Calculate full minutes M, update remainder
+ fullMinutes=$(( remainder / (60) ));
+ remainder=$(( remainder - (fullMinutes*60) ));
+ ## Calculate full seconds S, update remainder
+ fullSeconds=$(( remainder / (1) ));
+ remainder=$(( remainder - (remainder*1) ));
+ ## Check which fields filled
+ if [[ $fullYears -gt 0 ]]; then hasYears="true"; else hasYears="false"; fi
+ if [[ $fullMonths -gt 0 ]]; then hasMonths="true"; else hasMonths="false"; fi
+ if [[ $fullDays -gt 0 ]]; then hasDays="true"; else hasDays="false"; fi
+ if [[ $fullHours -gt 0 ]]; then hasHours="true"; else hasHours="false"; fi
+ if [[ $fullMinutes -gt 0 ]]; then hasMinutes="true"; else hasMinutes="false"; fi
+ if [[ $fullSeconds -gt 0 ]]; then hasSeconds="true"; else hasSeconds="false"; fi
+
+ ## Determine which fields to display (see ISO-8601:2004 §4.4.3.2)
+ witherPrecision="false"
+
+ ### Years
+ if $hasYears && [[ $precision -gt 0 ]]; then
+ displayYears="true";
+ witherPrecision="true";
+ else
+ displayYears="false";
+ fi;
+ if $witherPrecision; then ((precision--)); fi;
+
+ ### Months
+ if $hasMonths && [[ $precision -gt 0 ]]; then
+ displayMonths="true";
+ witherPrecision="true";
+ else
+ displayMonths="false";
+ fi;
+ if $witherPrecision && [[ $precision -gt 0 ]]; then
+ displayMonths="true";
+ fi;
+ if $witherPrecision; then ((precision--)); fi;
+
+ ### Days
+ if $hasDays && [[ $precision -gt 0 ]]; then
+ displayDays="true";
+ witherPrecision="true";
+ else
+ displayDays="false";
+ fi;
+ if $witherPrecision && [[ $precision -gt 0 ]]; then
+ displayDays="true";
+ fi;
+ if $witherPrecision; then ((precision--)); fi;
+
+ ### Hours
+ if $hasHours && [[ $precision -gt 0 ]]; then
+ displayHours="true";
+ witherPrecision="true";
+ else
+ displayHours="false";
+ fi;
+ if $witherPrecision && [[ $precision -gt 0 ]]; then
+ displayHours="true";
+ fi;
+ if $witherPrecision; then ((precision--)); fi;
+
+ ### Minutes
+ if $hasMinutes && [[ $precision -gt 0 ]]; then
+ displayMinutes="true";
+ witherPrecision="true";
+ else
+ displayMinutes="false";
+ fi;
+ if $witherPrecision && [[ $precision -gt 0 ]]; then
+ displayMinutes="true";
+ fi;
+ if $witherPrecision; then ((precision--)); fi;
+
+ ### Seconds
+
+ if $hasSeconds && [[ $precision -gt 0 ]]; then
+ displaySeconds="true";
+ witherPrecision="true";
+ else
+ displaySeconds="false";
+ fi;
+ if $witherPrecision && [[ $precision -gt 0 ]]; then
+ displaySeconds="true";
+ fi;
+ if $witherPrecision; then ((precision--)); fi;
+
+
+
+ ## Determine whether or not the "T" separator is needed to separate date and time elements
+ if ( $displayHours || $displayMinutes || $displaySeconds); then
+ displayDateTime="true"; else displayDateTime="false"; fi
+
+ ## Construct duration output string
+ OUTPUT="P"
+ if $displayYears; then
+ OUTPUT=$OUTPUT$fullYears"Y"; fi
+ if $displayMonths; then
+ OUTPUT=$OUTPUT$fullMonths"M"; fi
+ if $displayDays; then
+ OUTPUT=$OUTPUT$fullDays"D"; fi
+ if $displayDateTime; then
+ OUTPUT=$OUTPUT"T"; fi
+ if $displayHours; then
+ OUTPUT=$OUTPUT$fullHours"H"; fi
+ if $displayMinutes; then
+ OUTPUT=$OUTPUT$fullMinutes"M"; fi
+ if $displaySeconds; then
+ OUTPUT=$OUTPUT$fullSeconds"S"; fi
+
+ ## Output duration string to stdout
+ if [[ "$returnState" = "true" ]]; then echo "$OUTPUT"; fi
+
+ #===Determine function return code===
+ if [ "$returnState" = "true" ]; then
+ return 0;
+ else
+ echo "$returnState" 1>&2;
+ return 1;
+ fi
+
+} # Get duration (ex: PT10M4S )
+displayMissing() {
+ # Desc: Displays missing apps, files, and dirs
+ # Usage: displayMissing
+ # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
+ # Output: stderr messages
+ #==BEGIN Display errors==
+ #===BEGIN Display Missing Apps===
+ missingApps="Missing apps :"
+ #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
+ for key in "${!appRollCall[@]}"; do
+ value="${appRollCall[$key]}"
+ if [ "$value" = "false" ]; then
+ #echo "DEBUG:Missing apps: $key => $value";
+ missingApps="$missingApps""$key "
+ appMissing="true"
+ fi
+ done
+ if [ "$appMissing" = "true" ]; then # Only indicate if an app is missing.
+ echo "$missingApps" 1>&2;
+ fi
+ #===END Display Missing Apps===
+
+ #===BEGIN Display Missing Files===
+ missingFiles="Missing files:"
+ #for key in "${!fileRollCall[@]}"; do echo "DEBUG:$key => ${fileRollCall[$key]}"; done
+ for key in "${!fileRollCall[@]}"; do
+ value="${fileRollCall[$key]}"
+ if [ "$value" = "false" ]; then
+ #echo "DEBUG:Missing files: $key => $value";
+ missingFiles="$missingFiles""$key "
+ fileMissing="true"
+ fi
+ done
+ if [ "$fileMissing" = "true" ]; then # Only indicate if an app is missing.
+ echo "$missingFiles" 1>&2;
+ fi
+ #===END Display Missing Files===
+
+ #===BEGIN Display Missing Directories===
+ missingDirs="Missing dirs:"
+ #for key in "${!dirRollCall[@]}"; do echo "DEBUG:$key => ${dirRollCall[$key]}"; done
+ for key in "${!dirRollCall[@]}"; do
+ value="${dirRollCall[$key]}"
+ if [ "$value" = "false" ]; then
+ #echo "DEBUG:Missing dirs: $key => $value";
+ missingDirs="$missingDirs""$key "
+ dirMissing="true"
+ fi
+ done
+ if [ "$dirMissing" = "true" ]; then # Only indicate if an dir is missing.
+ echo "$missingDirs" 1>&2;
+ fi
+ #===END Display Missing Directories===
+
+ #==END Display errors==
+} # Display missing apps, files, dirs
+setScriptTTL() {
+ #Desc: Sets script TTL
+ #Usage: setScriptTTL arg1
+ #Input: arg1: "day" or "hour"
+ #Output: scriptTTL
+ #Depends: timeUntilNextHour or timeUntilNextDay
+ local ARG1
+ ARG1="$1"
+ if [[ "$ARG1" = "day" ]]; then
+ # Set script lifespan to end at start of next day
+ if ! scriptTTL="$(timeUntilNextDay)"; then
+ if [[ "$scriptTTL" -eq 0 ]]; then
+ ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+ else
+ yell "ERROR: timeUntilNextDay exit code $?"; exit 1;
+ fi;
+ fi;
+ elif [[ "$ARG1" = "hour" ]]; then
+ # Set script lifespan to end at start of next hour
+ if ! scriptTTL="$(timeUntilNextHour)"; then
+ if [[ "$scriptTTL" -eq 0 ]]; then
+ ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+ else
+ yell "ERROR: timeUntilNextHour exit code $?"; exit 1;
+ fi;
+ fi;
+ else
+ yell "ERROR:Invalid argument for setScriptTTL function."; exit 1;
+ fi
+} # Seconds until next (day|hour).
+checkMakeTar() {
+ # Desc: Checks that a valid tar archive exists, creates one otherwise
+ # Usage: checkMakeTar [ path ]
+ # Version: 1.0.1
+ # Input: arg1: path of tar archive
+ # Output: exit code 0 : tar readable
+ # exit code 1 : tar missing; created
+ # exit code 2 : tar not readable; moved; replaced
+ # Depends: try, tar, date
+ local PATH_TAR returnFlag0 returnFlag1 returnFlag2
+ PATH_TAR="$1"
+
+ # Check if file is a valid tar archive
+ if tar --list --file="$PATH_TAR" 1>/dev/null 2>&1; then
+ ## T1: return success
+ returnFlag0="tar valid";
+ else
+ ## F1: Check if file exists
+ if [[ -f "$PATH_TAR" ]]; then
+ ### T: Rename file
+ try mv "$PATH_TAR" "$PATH_TAR""--broken--""$(date +%Y%m%dT%H%M%S)" && \
+ returnFlag1="tar moved";
+ else
+ ### F: -
+ :
+ fi
+ ## F2: Create tar archive, return 0
+ try tar --create --file="$PATH_TAR" --files-from=/dev/null && \
+ returnFlag2="tar created";
+ fi
+
+ # Determine function return code
+ if [[ "$returnFlag0" = "tar valid" ]]; then
+ return 0;
+ elif [[ "$returnFlag2" = "tar created" ]] && ! [[ "$returnFlag1" = "tar moved" ]]; then
+ return 1; # tar missing so created
+ elif [[ "$returnFlag2" = "tar created" ]] && [[ "$returnFlag1" = "tar moved" ]]; then
+ return 2; # tar not readable so moved; replaced
+ fi
+} # checks if arg1 is tar; creates one otherwise
+appendArgTar(){
+ # Desc: Writes first argument to temporary file with arguments as options, then appends file to tar
+ # Usage: writeArg "$(echo "Data to be written.")" [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
+ # Input: arg1: data to be written
+ # arg2: file name of file to be inserted into tar
+ # arg3: tar archive path (must exist first)
+ # arg4: temporary working dir
+ # arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+ # Output: file written to disk
+ # Example: decrypt multiple large files in parallel
+ # appendArgTar "$(cat /tmp/largefile1.gpg)" "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendArgTar "$(cat /tmp/largefile2.gpg)" "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendArgTar "$(cat /tmp/largefile3.gpg)" "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # Depends: bash 5
+
+ # Save function name
+ local FN="${FUNCNAME[0]}"
+ yell "DEBUG:STATUS:$FN:Finished appendArgTar()."
+
+ # Set file name
+ if ! [ -z "$2" ]; then FILENAME="$2"; else yell "ERROR:$FN:Not enough arguments."; exit 1; fi
+
+ # Check tar path is a file
+ if [ -f "$3" ]; then TAR_PATH="$3"; else yell "ERROR:$FN:Tar archive arg not a file."; exit 1; fi
+
+ # Check temp dir arg
+ if ! [ -z "$4" ]; then TMP_DIR="$4"; else yell "ERROR:$FN:No temporary working dir set."; exit 1; fi
+
+ # Set command strings
+ if ! [ -z "$5" ]; then CMD1="$5"; else CMD1="tee /dev/null "; fi # command string 1
+ if ! [ -z "$6" ]; then CMD2="$6"; else CMD2="tee /dev/null "; fi # command string 2
+ if ! [ -z "$7" ]; then CMD3="$7"; else CMD3="tee /dev/null "; fi # command string 3
+ if ! [ -z "$8" ]; then CMD4="$8"; else CMD4="tee /dev/null "; fi # command string 4
+
+ # Debug
+ yell "STATUS:$FN:CMD1:$CMD1"
+ yell "STATUS:$FN:CMD2:$CMD2"
+ yell "STATUS:$FN:CMD3:$CMD3"
+ yell "STATUS:$FN:CMD4:$CMD4"
+ yell "STATUS:$FN:FILENAME:$FILENAME"
+ yell "STATUS:$FN:TAR_PATH:$TAR_PATH"
+ yell "STATUS:$FN:TMP_DIR:$TMP_DIR"
+ # Write to temporary working dir
+ echo "$1" | $CMD1 | $CMD2 | $CMD3 | $CMD4 > "$TMP_DIR"/"$FILENAME";
+
+ # Append to tar
+ try tar --append --directory="$TMP_DIR" --file="$TAR_PATH" "$FILENAME";
+ yell "DEBUG:STATUS:$FN:Finished appendArgTar()."
+} # Append Bash var to file appended to Tar archive
+magicWriteVersion() {
+ # Desc: Appends time-stamped VERSION to PATHOUT_TAR
+ # Usage: magicWriteVersion
+ # Input: CONTENT_VERSION, FILEOUT_VERSION, PATHOUT_TAR, DIR_TMP
+ # Depends: dateTimeShort, appendArgTar
+
+ # Generate VERSION file in BashVar
+ FILEOUT_VERSION="$(dateTimeShort)..VERSION";
+ CONTENT_VERSION="$(dateTimeShort):$(basename "$0")"" Version:""$SCRIPT_VERSION";
+ # Create BashVar as file FILEOUT_VERSION and write-append to PATHOUT_TAR
+ appendArgTar "$CONTENT_VERSION" "$FILEOUT_VERSION" "$PATHOUT_TAR" "$DIR_TMP";
+} # bkgpslog: write version data to PATHOUT_TAR via appendArgTar()
+magicWriteBuffer() {
+ # Desc: bkgpslog-specific meta function for writing data to DIR_TMP then appending each file to PATHOUT_TAR
+ # Inputs: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP
+ # Depends: yell, try, vbm, appendArgTar, tar
+ local FN="${FUNCNAME[0]}";
+ wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
+ vbm "DEBUG:STATUS:$FN:Started magicWriteBuffer().";
+
+ # Validate PATHOUT_TAR as tar.
+ checkMakeTar "$PATHOUT_TAR";
+ ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+ if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
+
+ # Write bufferBash to PATHOUT_TAR
+ appendArgTar "$bufferBash" "$FILEOUT_NMEA" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_NMEA" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write NMEA data
+ appendArgTar "$bufferBash" "$FILEOUT_GPX" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_GPX" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write GPX file
+ appendArgTar "$bufferBash" "$FILEOUT_KML" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_KML" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write KML file
+ # Remove secured chunks from DIR_TMP
+ try rm "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
+ yell "DEBUG:STATUS:$FN:Finished magicWriteBuffer().";
+} # bkgpslog write function
+